"live_migration" call in Liberty doesn't have backwards compatibility with Kilo

Bug #1576048 reported by Roman Sokolkov on 2016-04-28
10
This bug affects 2 people
Affects Status Importance Assigned to Milestone
OpenStack Compute (nova)
High
Wenzhi Yu
Liberty
High
Wenzhi Yu
Mitaka
High
Wenzhi Yu

Bug Description

"live_migration" call in Liberty doesn't have backwards compatibility with Kilo.

Liberty control plane and Kilo compute nodes.

Doing live-migration and getting error below on compute node

TypeError: live_migration() got an unexpected keyword argument 'migration'

Workaround(On controller): http://paste.openstack.org/show/495612/

Environment
==========
Libvirt+KVM, Ceph for VMs
Liberty - Mirantis OpenStack 8.0 (2015.2)
Kilo - 2015.1.3 tag

Steps to reproduce
===============
1) Install Liberty control plane (api, conductor, schduler, etc.)
2) Install Kilo compute
3) Add to nova.conf on controller
  [upgrade_levels]
  compute=kilo
3) Try "nova live-migration VM"

Expected result
=============
Migration will succeed

Actual result
==========
Traceback on compute node
http://paste.openstack.org/show/495541/

Wenzhi Yu (yuywz) on 2016-04-28
Changed in nova:
assignee: nobody → Wenzhi Yu (yuywz)
status: New → In Progress

Reviewed: https://review.openstack.org/310691
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=34b8336a41e2896f0639c402f64a05247f475fea
Submitter: Jenkins
Branch: master

commit 34b8336a41e2896f0639c402f64a05247f475fea
Author: Wenzhi Yu <wenzhi_yu@163.com>
Date: Thu Apr 28 16:06:57 2016 +0800

    Make compute rpcapi 'live_migration' backward compatible

    This commit[1] added compute rpcapi version 4.2 which introduced a new
    argument 'migration' when calling 'live_migration' method, but the code
    did not ensure the backward compatibility with older version compute
    node.

    When calling 'live_migration' method with 'migration' argument on older
    version(like Kilo) of nova compute node, a "TypeError: live_migration()
    got an unexpected keyword argument 'migration'" will be threw up.

    [1]https://github.com/openstack/nova/commit/2f4e64a7cf81de4a22fe2fc4210b1f795b1a3db4

    Change-Id: Ie5c498d34e7c4c6573d611abd592c25f1bcb4f44
    Closes-Bug: #1576048

Changed in nova:
status: In Progress → Fix Released
Wenzhi Yu (yuywz) on 2016-05-05
Changed in nova:
importance: Undecided → Medium

Fix proposed to branch: stable/liberty
Review: https://review.openstack.org/318556

Change abandoned by Wenzhi Yu (wenzhi_yu@163.com) on branch: stable/liberty
Review: https://review.openstack.org/312813
Reason: Wrong commit message, re-submitted in patch https://review.openstack.org/#/c/318556/

This issue was fixed in the openstack/nova 14.0.0.0b1 development milestone.

Matt Riedemann (mriedem) on 2016-06-07
Changed in nova:
importance: Medium → High

Reviewed: https://review.openstack.org/312812
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=0942228fd6f6192f2415338c5eda6f514833322a
Submitter: Jenkins
Branch: stable/mitaka

commit 0942228fd6f6192f2415338c5eda6f514833322a
Author: Wenzhi Yu <wenzhi_yu@163.com>
Date: Thu Apr 28 16:06:57 2016 +0800

    Make compute rpcapi 'live_migration' backward compatible

    This commit[1] added compute rpcapi version 4.2 which introduced a new
    argument 'migration' when calling 'live_migration' method, but the code
    did not ensure the backward compatibility with older version compute
    node.

    When calling 'live_migration' method with 'migration' argument on older
    version(like Kilo) of nova compute node, a "TypeError: live_migration()
    got an unexpected keyword argument 'migration'" will be threw up.

    [1]https://github.com/openstack/nova/commit/2f4e64a7cf81de4a22fe2fc4210b1f795b1a3db4

    Change-Id: Ie5c498d34e7c4c6573d611abd592c25f1bcb4f44
    Closes-Bug: #1576048
    (cherry picked from commit 34b8336a41e2896f0639c402f64a05247f475fea)

Reviewed: https://review.openstack.org/318556
Committed: https://git.openstack.org/cgit/openstack/nova/commit/?id=168409fa9313d3643eb7ceea6c8b5f2bef35d86f
Submitter: Jenkins
Branch: stable/liberty

commit 168409fa9313d3643eb7ceea6c8b5f2bef35d86f
Author: Wenzhi Yu <wenzhi_yu@163.com>
Date: Thu Apr 28 16:06:57 2016 +0800

    Make compute rpcapi 'live_migration' backward compatible

    This commit[1] added compute rpcapi version 4.2 which introduced a new
    argument 'migration' when calling 'live_migration' method, but the code
    did not ensure the backward compatibility with older version compute
    node.

    When calling 'live_migration' method with 'migration' argument on older
    version(like Kilo) of nova compute node, a "TypeError: live_migration()
    got an unexpected keyword argument 'migration'" will be threw up.

    [1]https://github.com/openstack/nova/commit/2f4e64a7cf81de4a22fe2fc4210b1f795b1a3db4

    Change-Id: Ie5c498d34e7c4c6573d611abd592c25f1bcb4f44
    Closes-Bug: #1576048
    (cherry picked from commit 34b8336a41e2896f0639c402f64a05247f475fea)

This issue was fixed in the openstack/nova 12.0.4 release.

This issue was fixed in the openstack/nova 13.1.0 release.

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers